=== tools/cpp/channel/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(channel CXX)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON) 
add_subdirectory(src)
